<head>
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <meta name='viewport' content='width=device-width, initial-scale=1'>
  <link rel='stylesheet' href='https://use.fontawesome.com/releases/v5.5.0/css/all.css'
        integrity='sha384-B4dIYHKNBt8Bc12p+WXckhzcICo0wtJAoU8YZTY5qE0Id1GSseTk6S+L3BlXeVIU' crossorigin='anonymous'>
</head>

<div class="container">
  <h2> Budgets</h2>
  <h3> Available income: {{currentUser.currentIncome}}</h3>
  <button class="addButton" (click)="showDialog(myAddTemplate)"> +</button>
  <div *ngIf="budgets.length == 0">
    <div class="alert alert-info" role="alert">No budgets yet.</div>
  </div>

  <div *ngIf="budgets.length > 0">
    <table mat-table (onSelectionChange)="updateData()" [dataSource]="budgets" class="mat-elevation-z8">

      <!-- Id Column -->
      <ng-container matColumnDef="budgetId">
        <th mat-header-cell *matHeaderCellDef [style.display]="'none'">
          userId
        </th>
        <td mat-cell *matCellDef="let budget" (click)="showExpenses(budget)"
            [style.display]="'none'"> {{budget.id}}</td>
      </ng-container>

      <!-- Name Column -->
      <ng-container matColumnDef="name">
        <th mat-header-cell *matHeaderCellDef> Name</th>
        <td mat-cell *matCellDef="let budget" (click)="showExpenses(budget)"> {{budget.budgetName}}</td>
      </ng-container>

      <!-- Income Column -->
      <ng-container matColumnDef="income">
        <th mat-header-cell *matHeaderCellDef> Income</th>
        <td mat-cell *matCellDef="let budget" (click)="showExpenses(budget)"> {{budget.income}}</td>
      </ng-container>

      <!-- Delete Column -->
      <ng-container matColumnDef="remove">
        <th mat-header-cell *matHeaderCellDef>Remove</th>
        <td mat-cell buttom (click)="removeBudget(row)"  *matCellDef="let row">
          <i class='fas fa-cut' style='font-size:24px'></i>
        </td>
      </ng-container>

      <!-- Update Column -->
      <ng-container matColumnDef="report">
        <th mat-header-cell *matHeaderCellDef>See Report</th>
        <td mat-cell button (click)="showReport(row,reportTemplate)" class="tableButton" *matCellDef="let row">
          <i class='far fa-eye' style='font-size:24px'></i>
        </td>
      </ng-container>

      <!-- AddExpenseColumn Column -->
      <ng-container matColumnDef="add">
        <th mat-header-cell *matHeaderCellDef>Add Expense</th>
        <td mat-cell button (click)="showDialogRememberRow(addExpenseTemplate, row)" class="tableButton"
            *matCellDef="let row"><i class='fas fa-save' style='font-size:24px'></i>
        </td>
      </ng-container>

      <!-- EditBUtton Column -->
      <ng-container matColumnDef="edit">
        <th mat-header-cell *matHeaderCellDef>Edit</th>
        <td mat-cell button (click)="showDialogRememberRow(updateBudgetTemplate, row)" class="tableButton"
            *matCellDef="let row"> <i class='fas fa-edit' style='font-size:24px'></i>
        </td>
      </ng-container>

      <tr mat-header-row *matHeaderRowDef="displayedColumns"></tr>
      <tr mat-row *matRowDef="let row; columns: displayedColumns;"></tr>
    </table>
  </div>


  <ng-template #myAddTemplate>
    <h2 style="color: gray">Add add a budget</h2>
    <form #f="ngForm">
      <input class="form-control" type="text" placeholder="name" name="budgetName" ngModel>
      <input class="form-control" type="number" placeholder="income" name="income" ngModel>
      <br>
      <br>
      <button type="submit" class="buttonStyle" mat-raised-button matDialogClose (click)="onSubmitCreate(f)">Save
      </button>
    </form>
    <mat-dialog-actions align="end">
    </mat-dialog-actions>
  </ng-template>

  <ng-template #reportTemplate>
    <h2 style="color: gray">Budget Report</h2>
    <form #f="ngForm">
      <canvas baseChart width="200px" height="150px"
              [data]="pieChartData"
              [labels]="pieChartLabels"
              [chartType]="pieChartType"
              [options]="pieChartOptions"
      ></canvas>
      <br>
      <br>
      <button type="submit" class="buttonStyle" mat-raised-button matDialogClose> Ok</button>
    </form>
    <mat-dialog-actions align="end">
    </mat-dialog-actions>
  </ng-template>

  <ng-template #addExpenseTemplate>
    <h2 style="color: gray">Add an expense to the budget</h2>
    <form #f="ngForm">
      <input class="form-control" type="number" placeholder="expense cost" name="value" ngModel>
      <select [(ngModel)]="expenseType" name="expenseType">
        <option *ngFor="let type of expenseTypes">
          {{type.value}}
        </option>
      </select>
      <br>
      <br>
      <button type="submit" class="buttonStyle" mat-raised-button matDialogClose (click)="addExpense(f)"> Add</button>
    </form>

    <mat-dialog-actions align="end">
    </mat-dialog-actions>
  </ng-template>

  <ng-template #updateBudgetTemplate >
    <h2 style="color: gray">Edit your budget</h2>
    <form #f="ngForm"  >
      <input class="form-control" type="text" placeholder="name" name="budgetName" ngModel>
      <input class="form-control" type="number" placeholder="income" name="income"  ngModel="{{clickedBudget.income}}" >
      <br>
      <br>
      <button type="submit" class="buttonStyle" mat-raised-button matDialogClose (click)="onSubmitUpdate(f)">Edit
      </button>
    </form>
    <mat-dialog-actions align="end">
    </mat-dialog-actions>
  </ng-template>

</div>
